#ifndef __IMAGE__
#define __IMAGE__

#include "misc.h"
#include "video.h"

#define NO_STRETCH     0
#define STRETCH        1
#define STRETCH_SCREEN 2
#define STRETCH_BIT0   3
#define STRETCH_BIT1   4

struct Image {
  int sizeX, sizeY, bytesPerLine;
  vidRGB* palette;
  void* buf;
  uchar* data;
  bool loaded;
  Image( char* name, int stretch=NO_STRETCH );
  Image( int sizex, int sizey, int bytesperline, vidRGB pal[256], uchar* buf );
  ~Image();
  void Show( int x, int y, PAGE );
  void ShowT( int x, int y, PAGE );
  void ShowAdd( int x, int y, PAGE page );
  void ShowTB( int x, int y, uchar color, PAGE );
  void ShowR( int x, int y, int w, int h, PAGE page );
  void ShowRT( int x, int y, int w, int h, PAGE page );
  void ShowRTC( int x, int y, int w, int h, uchar color, PAGE page );
  void ShowRTAdd( int x, int y, int w, int h, PAGE page );
  void StretchTo( int newx, int newy, int newbytesperline );
  void StretchToBit( int newx, int newy, bool neg );
};

#endif