#ifndef __MISC__
#define __MISC__

typedef unsigned char   uchar;
typedef unsigned short  ushort;
typedef unsigned int    uint;
typedef unsigned long   ulong;
typedef int             bool;
typedef unsigned char   uchar;
typedef unsigned short  ushort;
typedef unsigned int    uint;
typedef unsigned long   ulong;

#include <stdio.h>
#include <stdlib.h>
#include "video.h"

#define M_PI    3.141592653589

typedef int             bool;
#undef  false
#undef  true
#define false       ((bool)0)
#define true        ((bool)1)

#ifndef max
#define max(a,b)  (((a) > (b)) ? (a) : (b))
#endif
#ifndef min
#define min(a,b)  (((a) < (b)) ? (a) : (b))
#endif

#define sqr(x)  ((x)*(x))

#define PROJECT_NAME    "HElliZER"

extern int miscSoundCard, miscVideoMode;

#define cosSteps     4096
#define cosScale     6
#define cosScale3D   16
#define asinSteps    VID_MAX_SIZE_X

extern int cosTable[cosSteps], sinTable[cosSteps];
extern int cosTable3D[cosSteps], sinTable3D[cosSteps];
extern int asinTable[asinSteps];

void error( char* );

void* cmalloc( size_t size );
void cfree( void* ptr );

void Startup( bool saveconfig );
void Shutdown();

void miscSaveConfig( char* filename );
bool miscLoadConfig( char* filename );

typedef void (*miscTimerProc)(void);

void miscAddTimerProc( miscTimerProc );
void miscRemoveTimerProc( miscTimerProc );

class TCollection {
  int allocated;
public:
  void** Items;
  int Count;
  TCollection(void) {
    Count = 0; allocated = 0; Items = 0;
  };
  void Insert( void* );
  void Delete(int index);
  void Delete(void* item) { Delete(IndexOf(item)); };
  void PackDelete(int index);
  void PackDelete(void* item) { PackDelete(IndexOf(item)); };
  void Free(int index) { delete Items[index]; Delete(index); }
  void Free(void* item) { Free(IndexOf(item)); }
  void DeleteAll() { Count = 0; }
  void FreeAll();
  void* At(int index) { return Items[index]; }
  int IndexOf(void*);
  void Sort( int (*compare)(const void*,const void*) );
  void Pack();
  ~TCollection();
};

char* getToken(FILE* fp, const char* delimiters );

#define miscTimerRes    1000.0
void miscStartTimer();
uint miscTimer();

void memsetw( void* dst, ushort value, size_t length );

#endif