#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <conio.h>
#include <unistd.h>
#include <fcntl.h>
#include "resource.h"
#include "misc.h"
#include "mikmod\mikmod.h"
#include "zlib\zlib.h"

struct entry {
  char name[16];
  int offset, size;
} *table=0;

char* resource_name;
int resource_number=0;
int current=-1;

void resInit( char* name )
{
  resource_name = name;
//  printf( "%s\n", name );
  _fmode = O_BINARY;
  FILE* f = fopen( name, "rb" );
  if(f) {
    fseek( f, -4, SEEK_END );
    int n;
    fread( &n, sizeof(int), 1, f );
    if( n == 0x12345678 ) {
      fseek( f, -8, SEEK_END );
      fread( &n, sizeof(int), 1, f );
//      printf( "table offset=%d\n", n );
      fseek( f, n, SEEK_SET );
      fread( &resource_number, sizeof(int), 1, f );
//      printf( "resource_number=%d\n", resource_number );
      table = (entry*)cmalloc(sizeof(entry)*resource_number);
//      printf( "table=%d, size=%d\n", table, sizeof(entry)*resource_number );
//      getch();
      fread( table, sizeof(entry)*resource_number, 1, f );
//      for( int i=0; i<resource_number; i++ )
//        printf( "name=%s, offset=%d\n", table[i].name, table[i].offset );
//      getch();
    }
    fclose(f);
  }
}

FILE* fp=0;

FILE* resOpenFile( char* name )
{
  current=-1;
  fp = fopen( name, "rb" );
  if(!fp) {
    for( current=0; current<resource_number; current++ ) {
      if( !strcmp( strupr(name), table[current].name ) ) {
        fp = fopen( resource_name, "rb" );
        fseek( fp, table[current].offset, SEEK_SET );
        _mm_setiobase( table[current].offset );
        return fp;
      }
    }
    char str[256];
    sprintf( str, "Cannot open resource %s", name );
    error(str);
  }
//  printf( "Open resource %s\n", name );
  _mm_setiobase(0);
  return fp;
}

void* resGetResource( char* name )
{
  FILE* fp = resOpenFile(name);
  int size = resFileSize(fp);
  uchar* tmp = (uchar*)cmalloc(size);
  gzFile gzf = gzdopen( dup(fileno(fp)), "rb" );
  gzread( gzf, tmp, size );
  gzclose(gzf);
  resClose(fp);
  if( !strcmp( (char*)tmp, "RLE" ) ) {
    int newsize=*(int*)(tmp+4);
    uchar* outbuf=(uchar*)cmalloc(newsize);
    int i,j;
    for( i=8,j=0; i<size; i++ ) {
      if( tmp[i] > 0x80 ) {
        for( int k=0; k<(tmp[i]&0x7F); k++ ) {
          outbuf[j++] = tmp[i+1];
        }
        i++;
      }
      else {
        outbuf[j++]=tmp[i];
      }
    }
    if( j != newsize ) {
      char str[256];
      sprintf( str, "RLE decoding error (%s)", name );
      error(str);
    }
    cfree(tmp);
    tmp = outbuf;
  }
//  printf( "Got resource %s\n", name );
  return tmp;
}

void resFreeResource( void* ptr )
{
  cfree(ptr);
}

bool resEof( FILE* fp )
{
  if( current == -1 ) {
    return feof(fp);
  }
  else {
    int pos = ftell(fp);
    return( feof(fp) ||
            ftell(fp) > table[current].offset+table[current].size );
  }
}

void resClose( FILE* fp )
{
  fclose(fp);
}

int resFileSize( FILE* fp )
{
  if( current == -1 ) {
    long pos = ftell(fp);
    fseek(fp,0,SEEK_END);
    int size = ftell(fp);
    fseek(fp,pos,SEEK_SET);
    return size;
  }
  else {
    return table[current].size;
  }
}