#include <mem.h>
#include "video.h"
#include "smooth.h"

void _SmoothPage( PAGE frompage, PAGE topage );
#pragma aux _SmoothPage = \
"push ebp"\
"mov ebp,esi"\
"add ebp,vidPageSize"\
"mov ecx,vidBytesPerLine"\
"sub ebp,ecx"\
"sub ebp,ecx"\
"xor ebx,ebx"\
"xor edx,edx"\
"_loop:"\
"mov ax,[esi+ecx]"\
"movzx dx,al"\
"mov bl,ah"\
"neg ecx"\
"mov ax,[esi+ecx]"\
"add dl,al"\
"adc dh,0"\
"add bl,ah"\
"adc bh,0"\
"mov ax,[esi+1]"\
"add dl,al"\
"adc dh,0"\
"add bl,ah"\
"adc bh,0"\
"ror eax,16"\
"add dl,al"\
"adc dh,0"\
"add bl,ah"\
"adc bh,0"\
"shr dx,2"\
"shr bx,2"\
"mov dh,bl"\
"mov [edi],dx"\
"add esi,2"\
"add edi,2"\
"cmp esi,ebp"\
"jb _loop"\
"pop ebp"\
parm [esi] [edi]\
modify exact [eax ebx ecx edx esi edi];

void SmoothPage( PAGE frompage, PAGE topage ) {
  memset( topage, 0, vidBytesPerLine );
  _SmoothPage( frompage+vidBytesPerLine, topage+vidBytesPerLine );
  memset( topage+vidPageSize-vidBytesPerLine, 0, vidBytesPerLine );
}

void _SmoothPageNorm( PAGE frompage, PAGE topage, PAGE end, int size );
#pragma aux _SmoothPageNorm = \
"push ebp"\
"mov ebp,eax"\
"xor ebx,ebx"\
"xor edx,edx"\
"_loop:"\
"mov ax,[esi+ecx]"\
"movzx dx,al"\
"mov bl,ah"\
"neg ecx"\
"mov ax,[esi+ecx]"\
"add dl,al"\
"adc dh,0"\
"inc esi"\
"add bl,ah"\
"adc bh,0"\
"mov ax,[esi]"\
"add dl,al"\
"adc dh,0"\
"add bl,ah"\
"adc bh,0"\
"add bl,al"\
"adc bh,0"\
"ror eax,16"\
"add dl,al"\
"adc dh,0"\
"add bl,ah"\
"adc bh,0"\
"add dl,ah"\
"adc dh,0"\
"add dx,384"\
"add bx,384"\
"shr dx,3"\
"shr bx,3"\
"mov dh,bl"\
"mov [edi],dx"\
"inc esi"\
"add edi,2"\
"cmp esi,ebp"\
"jb _loop"\
"pop ebp"\
parm [esi] [edi] [eax] [ecx]\
modify exact [eax ebx ecx edx esi edi];

void SmoothPageNorm( PAGE frompage, PAGE topage ) {
  memset( topage, 128, vidBytesPerLine );
  _SmoothPageNorm( frompage+vidBytesPerLine, topage+vidBytesPerLine,
                   frompage+vidPageSize-2*vidBytesPerLine, vidBytesPerLine );
  memset( topage+vidPageSize-vidBytesPerLine, 128, vidBytesPerLine );
}

void _SmoothPageH( PAGE frompage, PAGE topage );
#pragma aux _SmoothPageH = \
"mov ecx,vidPageSize"\
"sub ecx,vidBytesPerLine"\
"shr ecx,1"\
"xor ebx,ebx"\
"xor edx,edx"\
"_loop:"\
"mov ax,[esi+1]"\
"movzx dx,al"\
"mov bl,ah"\
"ror eax,16"\
"add dl,al"\
"adc dh,0"\
"add bl,ah"\
"adc bh,0"\
"shr dx,1"\
"shr bx,1"\
"mov dh,bl"\
"mov [edi],dx"\
"add esi,2"\
"add edi,2"\
"dec ecx"\
"jnz _loop"\
parm [esi] [edi]\
modify exact [eax ebx ecx edx esi edi];

void SmoothPageH( PAGE frompage, PAGE topage ) {
  memset( topage, 0, vidBytesPerLine );
  _SmoothPageH( frompage+vidBytesPerLine, topage+vidBytesPerLine );
  memset( topage+vidPageSize-vidBytesPerLine, 0, vidBytesPerLine );
}

void _SmoothPageV( PAGE frompage, PAGE topage );
#pragma aux _SmoothPageV = \
"push ebp"\
"mov ebp,esi"\
"add ebp,vidPageSize"\
"mov ecx,vidBytesPerLine"\
"sub ebp,ecx"\
"xor ebx,ebx"\
"xor edx,edx"\
"_loop:"\
"mov ax,[esi+ecx]"\
"movzx dx,al"\
"mov bl,ah"\
"neg ecx"\
"mov ax,[esi+ecx]"\
"add dl,al"\
"adc dh,0"\
"add bl,ah"\
"adc bh,0"\
"shr dx,1"\
"shr bx,1"\
"mov dh,bl"\
"mov [edi],dx"\
"add esi,2"\
"add edi,2"\
"cmp esi,ebp"\
"jb _loop"\
"pop ebp"\
parm [esi] [edi]\
modify exact [eax ebx ecx edx esi edi];

void SmoothPageV( PAGE frompage, PAGE topage ) {
  memset( topage, 0, vidBytesPerLine );
  _SmoothPageV( frompage+vidBytesPerLine, topage+vidBytesPerLine );
  memset( topage+vidPageSize-vidBytesPerLine, 0, vidBytesPerLine );
}

void _SmoothPageHNorm( PAGE frompage, PAGE topage );
#pragma aux _SmoothPageHNorm = \
"mov ecx,vidPageSize"\
"sub ecx,vidBytesPerLine"\
"shr ecx,1"\
"xor ebx,ebx"\
"xor edx,edx"\
"_loop:"\
"mov ax,[esi+1]"\
"movzx dx,al"\
"mov bl,ah"\
"ror eax,16"\
"add dl,al"\
"adc dh,0"\
"add bx,256"\
"add bl,ah"\
"adc bh,0"\
"add dx,256"\
"shr bx,2"\
"shr dx,2"\
"mov dh,bl"\
"mov [edi],dx"\
"add esi,2"\
"add edi,2"\
"dec ecx"\
"jnz _loop"\
parm [esi] [edi]\
modify exact [eax ebx ecx edx esi edi];

void SmoothPageHNorm( PAGE frompage, PAGE topage ) {
  memset( topage, 128, vidBytesPerLine );
  _SmoothPageHNorm( frompage+vidBytesPerLine, topage+vidBytesPerLine );
  memset( topage+vidPageSize-vidBytesPerLine, 128, vidBytesPerLine );
}

void _SmoothPageVNorm( PAGE frompage, PAGE topage );
#pragma aux _SmoothPageVNorm = \
"push ebp"\
"mov ebp,esi"\
"add ebp,vidPageSize"\
"mov ecx,vidBytesPerLine"\
"sub ebp,ecx"\
"sub ebp,ecx"\
"xor ebx,ebx"\
"xor edx,edx"\
"_loop:"\
"mov ax,[esi+ecx]"\
"movzx dx,al"\
"mov bl,ah"\
"neg ecx"\
"mov ax,[esi+ecx]"\
"add dl,al"\
"adc dh,0"\
"add bx,256"\
"add bl,ah"\
"adc bh,0"\
"add dx,256"\
"shr bx,2"\
"shr dx,2"\
"mov dh,bl"\
"mov [edi],dx"\
"add esi,2"\
"add edi,2"\
"cmp esi,ebp"\
"jb _loop"\
"pop ebp"\
parm [esi] [edi]\
modify exact [eax ebx ecx edx esi edi];

void SmoothPageVNorm( PAGE frompage, PAGE topage ) {
  memset( topage, 128, vidBytesPerLine );
  _SmoothPageVNorm( frompage+vidBytesPerLine, topage+vidBytesPerLine );
  memset( topage+vidPageSize-vidBytesPerLine, 128, vidBytesPerLine );
}


void _AlignPage( PAGE page, uchar step, uchar value );
#pragma aux _AlignPage = \
"mov ecx,vidPageSize"\
"mov dh,dl"\
"neg dh"\
"_loop:"\
"mov bl,[esi]"\
"mov ah,bl"\
"sub bl,al"\
"jb _inc1"\
"cmp bl,dl"\
"jb _mov1"\
"sub ah,dl"\
"jmp _next1"\
"_mov1:"\
"mov ah,al"\
"jmp _next1"\
"_inc1:"\
"cmp bl,dh"\
"ja _mov1"\
"add ah,dl"\
"_next1:"\
"mov [esi],ah"\
"inc esi"\
"dec ecx"\
"jnz _loop"\
parm [esi] [dl] [al]\
modify exact [eax ebx ecx edx esi];

void AlignPage( PAGE page, uchar step, uchar value ) {
  _AlignPage( page, step, value );
}

void _AlignToPage( PAGE frompage, PAGE topage, uchar step );
#pragma aux _AlignToPage = \
"mov ecx,vidPageSize"\
"mov dh,dl"\
"neg dh"\
"_loop:"\
"mov bl,[esi]"\
"mov al,[edi]"\
"mov ah,bl"\
"sub bl,al"\
"jb _inc1"\
"cmp bl,dl"\
"jb _mov1"\
"sub ah,dl"\
"jmp _next1"\
"_mov1:"\
"mov ah,al"\
"jmp _next1"\
"_inc1:"\
"cmp bl,dh"\
"ja _mov1"\
"add ah,dl"\
"_next1:"\
"mov [esi],ah"\
"inc esi"\
"inc edi"\
"dec ecx"\
"jnz _loop"\
parm [esi] [edi] [dl]\
modify exact [eax ebx ecx edx esi];

void AlignToPage( PAGE frompage, PAGE topage, uchar step )
{
  _AlignToPage( frompage, topage, step );
}