#include <io.h>
#include <fcntl.h>
#include <unistd.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "..\zlib\zlib.h"

struct {
  char name[16];
  int offset, size;
} table[100];

int count=0;

int copy_file( int to, int from, int compress )
{
  static char buf[65536];
  int pos = tell(to);
  while( !eof(from) ) {
    int size = read( from, buf, sizeof(buf) );
    if( compress ) {
      gzFile gzf = gzdopen( dup(to), "wb9" );
      if( !gzf ) {
        perror( "gzdopen failed" );
        exit(0);
      }
      if( !gzwrite( gzf, buf, size ) ) {
        perror( "gzwrite failed" );
        exit(0);
      }
      gzclose( gzf );
    }
    else {
      write( to, buf,  size );
    }
  }
  return pos;
}

void main( int argc, char* argv[] )
{
  _fmode = O_BINARY;
  int exe = open( strupr(argv[1]), O_RDWR|O_CREAT, S_IREAD|S_IWRITE );
  lseek( exe, 0, SEEK_END );
  for( int i=2; i<argc; i++ ) {
    find_t buf;
    if( !_dos_findfirst( argv[i], _A_NORMAL, &buf ) ) {
      do {
        strupr(buf.name);
        if( strcmp( buf.name, strupr(argv[0]) ) &&
            strcmp( buf.name, strupr(argv[1]) ) ) {
          puts( buf.name );
          int h = open( buf.name, O_RDONLY );
          char names[_MAX_PATH2], *dr, *d, *n, *e;
          _splitpath2( buf.name, names, &dr, &d, &n, &e );
          int compress = e[1] == 'R' ? 1 : 0;
          printf( "offset=%d, size=%d\n",
                  table[count].offset = copy_file( exe, h, compress ),
                  table[count].size = filelength(h) );
          close(h);
          strcpy( table[count++].name, buf.name );
        }
      } while( !_dos_findnext(&buf) );
    }
  }
  int tab_pos = tell(exe);
  write( exe, &count, sizeof(int) );
  write( exe, table, sizeof(table[0])*count );
  write( exe, &tab_pos, sizeof(int) );
  int sign = 0x12345678;
  write( exe, &sign, 4 );
}