#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>

unsigned char *buf, *outbuf;

#define HIGH_BITS 1

struct {
  char s[4];
  int size;
} head;

void main( int argc, char* argv[] ) {
  _fmode = O_BINARY;
  int from = open( argv[1], O_RDONLY );
  char names[_MAX_PATH2], *dr, *d, *n, *e;
  _splitpath2( argv[1], names, &dr, &d, &n, &e );
  e = ".rle";
  _makepath( argv[1], "", "", n, e );
  int to = open( argv[1], O_WRONLY|O_CREAT, S_IREAD|S_IWRITE );
  int size=filelength(from);
  strcpy( head.s, "RLE" );
  head.size = size;
  write( to, &head, sizeof(head) );
  buf=(unsigned char*)malloc( size ); outbuf=(unsigned char*)malloc( size );
  read( from, buf, size );
  int i=0, j=0;
  for(;;) {
    char b=buf[i++];
    unsigned char count=1;
    while( i < size && buf[i]==b && count < (unsigned char)(0xFF>>HIGH_BITS) ) {
      count++; i++;
    }
    if( count>1 || b > (unsigned char)(0xFF<<(8-HIGH_BITS) ) ) {
      if( j >= size ) {
        printf( "No compression needed\n" );
        close(to);
        unlink( argv[1] );
        return;
      }
      outbuf[j++] = (0xFF<<(8-HIGH_BITS)) | count;
      outbuf[j++] = b;
    }
    else {
      outbuf[j++]=b;
      if( j >= size ) {
        printf( "No compression needed\n" );
        close(to);
        unlink( argv[1] );
        return;
      }
    }
    if( i >= size ) break;
  }
  write( to, outbuf, j );
  close(from);
  close(to);
}
